#include "lidar_lite.h"

CLidarLite::CLidarLite(void)
{
}
 
CLidarLite::~CLidarLite(void)
{
	close();
	if(this->adapter_ != NULL)
		delete this->adapter_;
}

void CLidarLite::blink_led(void)
{
	try
	{
		for (int ii = 0; ii < 2; ++ii)
		{
      this->adapter_->turn_led_off();
      usleep(200000);
      this->adapter_->turn_led_on();
      usleep(200000);
		}
  }catch(CException &e)
  {
  	throw CLidarLiteException(_HERE_, e.what());
  }
}

void CLidarLite::open(const std::string& serial)
{
	this->adapter_ = new CUSBI2C("adapter");
	try
	{
		// open serial port
    std::cout << "[CLidarLite] Opening Lidar Lite. " << std::endl; 
    this->adapter_->open(serial);
    std::cout << "  - Serial number: " << serial << std::endl;
    std::cout << "  - Firmware revision: " << (int)this->adapter_->get_revision() << std::endl;

    // blink led
    blink_led();
		
		// Setup gpio 2 as i2c    
    this->adapter_->config_gpio(gpio2,i2c);

    // Test

		
		// unsigned char param1 = 0x00;
		unsigned char data = 0x04;

    this->adapter_->write_reg(gpio2, 0x00, &data, 1);

		// this->adapter_->write(0x00, &data, 1);

		//int CUSBI2C::write_reg(unsigned char dev_id, short int address, unsigned char *data, int len)
  


  //Write 0x04 to register 0x00.

	//Read register 0x01. Repeat until bit 0 (LSB) goes low.
			
	//Read two bytes from 0x8f (High byte 0x0f then low byte 0x10) to obtain the 16-bit measured distance in centimeter

  }catch(CException &e)
  {
  	throw CLidarLiteException(_HERE_, e.what());
  }
}

void CLidarLite::close(void)
{
	try
	{
		this->adapter_->close();
  }catch(CException &e)
  {
  	throw CLidarLiteException(_HERE_, e.what());
  }
}
